--------------------------------------------------------------------
-- Events
--------------------------------------------------------------------


---------------------------
-- event functions
---------------------------
function Glance.Functions.setAddOnEvents()
	function Glance.Events:ADDON_LOADED(...)  end
	function Glance.Events:TIME_PLAYED_MSG(...)  end
	function Glance.Events:PLAYER_ENTERING_WORLD(...) 			Glance.Functions.checkUI() end
	function Glance.Events:PLAYER_LOGOUT(...)  end
	function Glance.Events:CHAT_MSG_COMBAT_XP_GAIN(...)  end
	function Glance.Events:QUEST_COMPLETE(...)  end
	function Glance.Events:CHAT_MSG_ADDON(...)  end
	function Glance.Events:PLAYER_LEVEL_UP(...)  end
	function Glance.Events:PLAYER_XP_UPDATE(...)  end
	function Glance.Events:BN_FRIEND_ACCOUNT_OFFLINE(...) 		Glance.Functions.updateFriends() end
	function Glance.Events:BN_FRIEND_ACCOUNT_ONLINE(...) 		Glance.Functions.updateFriends() end
	function Glance.Events:CHAT_MSG_SKILL(...) 					Glance.Functions.updateProfessions() end
	function Glance.Events:COMPANION_LEARNED(...) 				Glance.Functions.resetMountList() Glance.Functions.updateMounts() Glance.Functions.resetPetList() Glance.Functions.updatePets()end
	function Glance.Events:FRIENDLIST_UPDATE(...) 				Glance.Functions.updateFriends() end
	function Glance.Events:GUILD_ROSTER_UPDATE(...) 			Glance.Functions.updateGuild() end
	function Glance.Events:HONOR_CURRENCY_UPDATE(...) 			Glance.Functions.updateEmblems() end
	function Glance.Events:KNOWN_CURRENCY_TYPES_UPDATE(...) 	Glance.Functions.updateEmblems() end
	function Glance.Events:LFG_COMPLETION_REWARD(...) 			Glance.Functions.updateEmblems() end
	function Glance.Events:MERCHANT_SHOW(...) 					Glance.Functions.repairArmor() end
	function Glance.Events:PLAYER_GUILD_UPDATE(...) 			Glance.Functions.updateGuild() end
	function Glance.Events:PLAYER_MONEY(...) 					Glance.Functions.updateCurrency() end
	function Glance.Events:UNIT_DAMAGE(...) 					Glance.Functions.updateArmor() end
	function Glance.Events:UPDATE_FACTION(...) 					Glance.Functions.updateRep() end
	function Glance.Events:UPDATE_INVENTORY_DURABILITY(...) 	Glance.Functions.updateArmor() end
	function Glance.Events:PLAYER_LOGIN(...) 					Glance.Functions.getAddons() end
end

---------------------------
-- register events
---------------------------
function Glance.Functions.registerEvents()
	for k, v in pairs(Glance.Events) do
		Glance.Frames.mainFrame:RegisterEvent(k)
	end
end

---------------------------
-- button event handlers
---------------------------
function Glance.Functions.setButtonEvents()
	Glance.Buttons.Gold:SetScript("OnEnter", function(...) if Glance_Options.showGold then Glance.Functions.setTT(Glance.Buttons.Gold) end end)
	Glance.Buttons.Gold:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Emblems:SetScript("OnEnter", function(...) if Glance_Options.showEmblems then Glance.Functions.setTT(Glance.Buttons.Emblems) end end)
	Glance.Buttons.Emblems:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Emblems:SetScript("OnClick", function(...) if Glance_Options.showEmblems then ToggleCharacter("TokenFrame") end end)
	Glance.Buttons.Friends:SetScript("OnEnter", function(...) if Glance_Options.showFriends then Glance.Functions.setTT(Glance.Buttons.Friends) end end)
	Glance.Buttons.Friends:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Friends:SetScript("OnClick", function(...) if Glance_Options.showFriends then ToggleFriendsFrame(1) end end)
	Glance.Buttons.Guild:SetScript("OnEnter", function(...) if Glance_Options.showGuild then Glance.Functions.setTT(Glance.Buttons.Guild) end end)
	Glance.Buttons.Guild:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Guild:SetScript("OnClick", function(...) if Glance_Options.showGuild then ToggleGuildFrame(1) end end)
	Glance.Buttons.Armor:SetScript("OnEnter", function(...) if Glance_Options.showArmor then Glance.Functions.setTT(Glance.Buttons.Armor) end end)
	Glance.Buttons.Armor:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.XP:SetScript("OnEnter", function(...) if Glance_Options.showXP then Glance.Functions.setTT(Glance.Buttons.XP) end end)
	Glance.Buttons.XP:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Rep:SetScript("OnEnter", function(...) if Glance_Options.showRep then Glance.Functions.setTT(Glance.Buttons.Rep) end end)
	Glance.Buttons.Rep:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Lag:SetScript("OnEnter", function(...) if Glance_Options.showLag then Glance.Functions.setTT(Glance.Buttons.Lag) end end)
	Glance.Buttons.Lag:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.FPS:SetScript("OnEnter", function(...) if Glance_Options.showFPS then Glance.Functions.setTT(Glance.Buttons.FPS) end end)
	Glance.Buttons.FPS:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Mem:SetScript("OnClick", function(...) if Glance_Options.showLag then if IsShiftKeyDown() then ShowUIPanel(ACP_AddonList) else Glance.Functions.collectGarbage() end end end)
	Glance.Buttons.Mem:SetScript("OnEnter", function(...) if Glance_Options.showMem then Glance.Functions.setTT(Glance.Buttons.Mem) end end)
	Glance.Buttons.Mem:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Mounts:SetScript("OnEnter", function(...) if Glance_Options.showMounts then Glance.Functions.setTT(Glance.Buttons.Mounts) end end)
	Glance.Buttons.Mounts:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Pets:SetScript("OnEnter", function(...) if Glance_Options.showPets then Glance.Functions.setTT(Glance.Buttons.Pets) end end)
	Glance.Buttons.Pets:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.WG:SetScript("OnEnter", function(...) if Glance_Options.showWG then Glance.Functions.setTT(Glance.Buttons.WG) end end)
	Glance.Buttons.WG:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.TB:SetScript("OnEnter", function(...) if Glance_Options.showTB then Glance.Functions.setTT(Glance.Buttons.TB) end end)
	Glance.Buttons.TB:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Professions:SetScript("OnEnter", function(...) if Glance_Options.showProfessions then Glance.Functions.setTT(Glance.Buttons.Professions) end end)
	Glance.Buttons.Professions:SetScript("OnLeave", Glance.Functions.hideTooltip)
	
	Glance.Buttons.Time:RegisterForClicks("AnyUp")
	Glance.Buttons.Time:SetScript("OnEnter", function(...) if Glance_Options.showClock then Glance.Functions.setTT(Glance.Buttons.Time) end end)
	Glance.Buttons.Time:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Time:SetScript("OnClick", function(self, button, down) if Glance_Options.showClock then Glance.Functions.Time(button) end end)
	
	Glance.Buttons.XP:SetScript("OnClick", function(...) if Glance_Options.showXP then Glance.Functions.addonQuery("GlanceQuery","Data Please") end end)
	
	Glance.Frames.mainFrame:RegisterForClicks("AnyUp")
	Glance.Frames.mainFrame:SetScript("OnClick", function(self, button, down) if (button == "RightButton") then InterfaceOptionsFrame_OpenToCategory(panel2) end end)

	Glance.Buttons.Rep:SetScript("OnClick", function(...) if Glance_Options.showRep then Glance.Functions.menuToggleRep(Glance.Buttons.Rep, button, ...) Glance.Functions.hideTooltip() end end)
	Glance.Buttons.Professions:SetScript("OnClick", function(...) if Glance_Options.showProfessions then Glance.Functions.menuToggleProfession(Glance.Buttons.Professions, button, ...) Glance.Functions.hideTooltip() end end)
	Glance.Buttons.Mounts:SetScript("OnClick", function(...) if Glance_Options.showMounts then Glance.Functions.menuToggleMount(Glance.Buttons.Mounts, button, ...) Glance.Functions.hideTooltip() end end)
	Glance.Buttons.Pets:SetScript("OnClick", function(...) if Glance_Options.showPets then Glance.Functions.menuTogglePet(Glance.Buttons.Pets, button, ...) Glance.Functions.hideTooltip() end end)
end

---------------------------
-- onEvent/onUpdate handler
---------------------------
function Glance.Functions.setAddOnHandlers()
	Glance.Frames.mainFrame:SetScript("OnEvent", function(self, event, arg1, arg2, arg3, arg4)
		if event=="ADDON_LOADED" and arg1 == "Glance" then
			Glance.Functions.sendMSG("v"..GetAddOnMetadata("Glance","Version").." loaded.  Type '/glance options' to set your preferences.")
			Glance.Functions.loadDefaultVariables()
			Glance.Frames.mainFrame:SetScript("OnUpdate", function(...) Glance.Functions.firstLoad() end)
		elseif (event == "TIME_PLAYED_MSG") then
			Glance.Variables.gametime.initTotal = time() - arg1
			Glance.Variables.gametime.initLevel = time() - arg2
			if Glance_Options.timePlayed and not Glance.Variables.timePlayed then
				Glance.Functions.sendMSG("Total Time Played: "..Glance.Functions.formatTime(time() - Glance.Variables.gametime.initTotal))
				Glance.Functions.sendMSG("Time Played This Level: "..Glance.Functions.formatTime(time() - Glance.Variables.gametime.initLevel))
				Glance.Variables.timePlayed = true
			end
		elseif (event == "CHAT_MSG_COMBAT_XP_GAIN") then
			Glance.Functions.onChatXPGain(arg1)
		elseif (event == "QUEST_COMPLETE") then
			Glance.Variables.questCompleteOpen = true
		elseif (event == "CHAT_MSG_ADDON") then
			Glance.Functions.addonResponse(arg1,arg2,arg3,arg4)
		elseif (event == "PLAYER_LEVEL_UP") then
			Glance.Variables.xp.accumulated = Glance.Variables.xp.accumulated + UnitXPMax("player") - Glance.Variables.xp.init
			Glance.Variables.xp.init = 0
			Glance.Variables.gametime.initLevel = time()
		elseif (event == "PLAYER_XP_UPDATE") then
			Glance.Functions.addonQuery("GlanceQuery","xperhour")
			Glance.Functions.updateXP()
		else
			if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cff00ff00EVT: "..event) end
			Glance.Events[event](self, event, arg1)
		end
	end)

end

---------------------------
-- onUpdate first load
---------------------------
function Glance.Functions.firstLoad() 
	if Glance.Variables.Delay and Glance_Options ~= nil and Glance.Variables ~= nil then
		if Glance_Options.moveUI then
			Glance.Functions.moveUI()
		end
		Glance.Frames.mainFrame:SetScale(Glance_Options.frameScale)
		Glance.Functions.updateAll()
		Glance.Variables.xp.init = UnitXP("player")
		Glance.Variables.gold = GetMoney()
		Glance.Variables.gametime.initSession = time()
		Glance.Variables.requestingTimePlayed = true
		RequestTimePlayed()
		ToggleDropDownMenu(1, nil, Glance.Menus.Pets, Glance.Buttons.Pets, 0, 0)
		ToggleDropDownMenu(1, nil, Glance.Menus.Pets, Glance.Buttons.Pets, 0, 0)--on off on to properly set the font size.
		ToggleDropDownMenu(1, nil, Glance.Menus.Mounts, Glance.Buttons.Mounts, 0, 0)
		ToggleDropDownMenu(1, nil, Glance.Menus.Mounts, Glance.Buttons.Mounts, 0, 0)
		ToggleDropDownMenu(1, nil, Glance.Menus.Profession, Glance.Buttons.Professions, 0, 0)
		ToggleDropDownMenu(1, nil, Glance.Menus.Profession, Glance.Buttons.Professions, 0, 0)
		ToggleDropDownMenu(1, nil, Glance.Menus.Rep, Glance.Buttons.Rep, 0, 0)
		ToggleDropDownMenu(1, nil, Glance.Menus.Rep, Glance.Buttons.Rep, 0, 0)
		Glance.Functions.updateProfessions()
		Glance.Frames.mainFrame:SetScript("OnUpdate", function(self,elapsed) Glance.Functions.onUpdate(self,elapsed) end)
		Glance.Variables.Delay = false 
		if Glance_Options.collectGarbage then
			Glance.Functions.collectGarbage() 
		end
		Glance.Functions.resetMountList()
		Glance.Functions.resetPetList()
		Glance.Functions.createOptionsPanel()
		Glance.Functions.setOptionValues()
	end
end

---------------------------
-- onUpdate timers
---------------------------
function Glance.Functions.onUpdate(self,elapsed)
	Glance.Variables.TimeSinceLastUpdate = Glance.Variables.TimeSinceLastUpdate + elapsed
	Glance.Variables.TimeSinceLastMemUpdate = Glance.Variables.TimeSinceLastMemUpdate + elapsed
	if Glance.Variables.TimeSinceLastUpdate >= 1 then
		Glance.Functions.updateLag()
		Glance.Functions.updateFPS()
		Glance.Functions.updateLocation()
		Glance.Functions.updateClock()
		--if not IsInInstance() then
			Glance.Functions.updateWG();
			Glance.Functions.updateTB();
		--end
		if GameTooltip:IsShown() then
			if GameTooltip:GetOwner() == Glance.Buttons.Mem then
				Glance.Functions.setTT(Glance.Buttons.Mem)
			elseif GameTooltip:GetOwner() == Glance.Buttons.Lag then
				Glance.Functions.setTT(Glance.Buttons.Lag)
			elseif GameTooltip:GetOwner() == Glance.Buttons.FPS then
				Glance.Functions.setTT(Glance.Buttons.FPS)
			elseif GameTooltip:GetOwner() == Glance.Buttons.XP then
				Glance.Functions.setTT(Glance.Buttons.XP)
			end
		end
		Glance.Variables.TimeSinceLastUpdate = 0
		Glance.Variables.overflowFix = true
	end
	if Glance.Variables.TimeSinceLastMemUpdate >= 5 then
		Glance.Functions.updateEmblems()
		GuildRoster()
		Glance.Variables.TimeSinceLastMemUpdate = 0
	end
end