--------------------------------------------------------------------
-- Button text updates
--------------------------------------------------------------------


---------------------------
-- update data
---------------------------
function Glance.Functions.updateAll()
	Glance.Functions.updateCurrency()
	Glance.Functions.updateEmblems()
	Glance.Functions.updateFriends()
	Glance.Functions.updateGuild()
	Glance.Functions.updateRep()
	Glance.Functions.updateLag()
	Glance.Functions.updateFPS()
	Glance.Functions.updateMem()
	Glance.Functions.updateArmor()
	Glance.Functions.updateXP()
	Glance.Functions.updateProfessions()
	Glance.Functions.updateMounts()
	Glance.Functions.updatePets()
	Glance.Functions.updateWG()
	Glance.Functions.updateTB()
	if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf40bcbUDT: Glance.Functions.updateAll()") end
end

---------------------------
-- reset display data
---------------------------
function Glance.Functions.resetButton(btn,parent,side,pos,space,text)
	btn:SetText(text)
	if text ~= "" then btn:SetWidth(btn:GetTextWidth()) else btn:SetWidth(1) end
	btn:SetPoint(side, parent, pos, space, 0)
end

---------------------------
-- currency update
---------------------------
function Glance.Functions.updateCurrency()
	if Glance_Options.showGold then
		local foundPlayer = false
		local englishFaction, localizedFaction = UnitFactionGroup("player")
		Glance.Functions.resetButton(Glance.Buttons.Gold,Glance.Frames.mainFrame,"LEFT","LEFT",5,GetCoinTextureString(GetMoney(),0))
		if englishFaction == "Horde" then
			if Glance_Global.HordeGold == nil then Glance_Global.HordeGold = {} end
			if Glance_Global.HordeGold[1] == nil then
				Glance_Global.HordeGold[1] = { UnitName("player"), GetMoney() }
			else
				for i=1,#Glance_Global.HordeGold do
					if Glance_Global.HordeGold[i][1] == UnitName("player") then
						Glance_Global.HordeGold[i] = { UnitName("player"), GetMoney() }
						foundPlayer = true
					end
				end
				if not foundPlayer then
					Glance_Global.HordeGold[#Glance_Global.HordeGold+1] = { UnitName("player"), GetMoney() }
				end
			end
		else
			if Glance_Global.AllianceGold == nil then Glance_Global.AllianceGold = {} end
			if Glance_Global.AllianceGold[1] == nil then
				Glance_Global.AllianceGold[1] = { UnitName("player"), GetMoney() }
			else
				for i=1,#Glance_Global.AllianceGold do
					if Glance_Global.AllianceGold[i][1] == UnitName("player") then
						Glance_Global.AllianceGold[i] = { UnitName("player"), GetMoney() }
						foundPlayer = true
					end
				end
				if not foundPlayer then
					Glance_Global.AllianceGold[#Glance_Global.AllianceGold+1] = { UnitName("player"), GetMoney() }
				end
			end
		end
		if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateCurrency()") end
	else Glance.Functions.resetButton(Glance.Buttons.Gold,Glance.Frames.mainFrame,"LEFT","LEFT",0,"") end
end

---------------------------
-- emblem update
---------------------------
function Glance.Functions.updateEmblems()
	if Glance_Options.showEmblems then
		local BT,JP,HP,VP = "","|cffff00000","|cffff00000","|cffff00000"
		for i=1, GetCurrencyListSize() do
			local name,_,_,_,_,count,_,icon,_ = GetCurrencyListInfo(i)
			if name == "Justice Points" then JP = count end
			if name == "Honor Points" then HP = count end
			if name == "Valor Points" then VP = count end
		end
		if VP =="4000" then VP = "|cffff0000cap" end
		if JP =="4000" then JP = "|cffff0000cap" end
		if HP =="4000" then HP = "|cffff0000cap" end
		BT = "VP: |cffffd700"..VP.." |r"
		BT = BT.."   JP: |cffffd700"..JP.." |r"
		BT = BT.."   HP: |cffffd700"..HP
		Glance.Functions.resetButton(Glance.Buttons.Emblems,Glance.Buttons.Gold,"LEFT","RIGHT",Glance.Variables.spacer,BT)
		--if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateEmblems()") end
	else Glance.Functions.resetButton(Glance.Buttons.Emblems,Glance.Buttons.Gold,"LEFT","RIGHT",0,"") end
end

---------------------------
-- friends update
---------------------------
function Glance.Functions.updateFriends()
	if Glance_Options.showFriends then
		local _,numFriends = GetNumFriends()
		local _,bnFriends = BNGetNumFriends()
		local friends = "Friends:|cff00FF00".." "..numFriends + bnFriends
		Glance.Functions.resetButton(Glance.Buttons.Friends,Glance.Buttons.Emblems,"LEFT","RIGHT",Glance.Variables.spacer,friends)
		if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateFriends()") end
	else Glance.Functions.resetButton(Glance.Buttons.Friends,Glance.Buttons.Emblems,"LEFT","RIGHT",0,"") end
end

---------------------------
-- guild update
---------------------------
function Glance.Functions.updateGuild()
	if Glance_Options.showGuild then
		local guild
		if IsInGuild() then
			local onlineTotal = 0
			for i = 1, GetNumGuildMembers(true) do
				 local online = select(9, GetGuildRosterInfo(i))
				 if online then
					onlineTotal = onlineTotal + 1
				 end
			end
			guild = "Guild:|cff00FF00".." "..onlineTotal
		else
			guild = "Guild:|cffFF0000 0"
		end
		Glance.Functions.resetButton(Glance.Buttons.Guild,Glance.Buttons.Friends,"LEFT","RIGHT",Glance.Variables.spacer,guild)
		--if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateGuild()") end
	else Glance.Functions.resetButton(Glance.Buttons.Guild,Glance.Buttons.Friends,"LEFT","RIGHT",0,"") end
end

---------------------------
-- armor update
---------------------------
function Glance.Functions.updateArmor()
	if Glance_Options.showArmor then
		Glance.Functions.resetButton(Glance.Buttons.Armor,Glance.Buttons.Guild,"LEFT","RIGHT",Glance.Variables.spacer,"Armor:|cff00FF00".." "..Glance.Functions.GetDurability().."%")
		if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateArmor()") end
	else Glance.Functions.resetButton(Glance.Buttons.Armor,Glance.Buttons.Guild,"LEFT","RIGHT",0,"") end
end

---------------------------
-- xp update
---------------------------
function Glance.Functions.updateXP()
	if Glance_Options.showXP then
		if UnitLevel("player") < 85 then
			Glance.Functions.setXP()
			Glance.Functions.resetButton(Glance.Buttons.XP,Glance.Buttons.Armor,"LEFT","RIGHT",Glance.Variables.spacer,"|rXP: |c0000ff00"..Glance.Variables.xp.currentPCT.."%|r")
		else
			Glance.Functions.resetButton(Glance.Buttons.XP,Glance.Buttons.Armor,"LEFT","RIGHT",Glance.Variables.spacer,"|rXP: |c0000ff00max")
		end
		if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateXP()") end
	else Glance.Functions.resetButton(Glance.Buttons.XP,Glance.Buttons.Armor,"LEFT","RIGHT",0,"") end
end

---------------------------
-- rep update
---------------------------
function Glance.Functions.updateRep()
	if Glance_Options.showRep then
		local rep = ""
		for i=1,GetNumFactions() do
			local _,_,_,bottomValue,topValue,earnedValue,_,_,_,_,_,isWatched,_ = GetFactionInfo(i)
			if isWatched then
				rep = "REP: "..Glance.Arrays.colors[Glance.Arrays.rep[""..topValue]]..Glance.Functions.getRep(bottomValue,earnedValue,topValue)
			end
		end
		Glance.Functions.resetButton(Glance.Buttons.Rep,Glance.Buttons.XP,"LEFT","RIGHT",Glance.Variables.spacer,rep)
		if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateRep()") end
	else Glance.Functions.resetButton(Glance.Buttons.Rep,Glance.Buttons.XP,"LEFT","RIGHT",0,"") end
end

---------------------------
-- profession update
---------------------------
function Glance.Functions.updateProfessions()
	if Glance_Options.showProfessions then
		if Glance_Options.Profession ~= 0 then
			local name, icon, skillLevel, maxSkillLevel,_,_,_,_ = GetProfessionInfo(Glance_Options.Profession)
			if maxSkillLevel ~= nil then 
				Glance.Functions.resetButton(Glance.Buttons.Professions,Glance.Buttons.Rep,"LEFT","RIGHT",Glance.Variables.spacer,name..": |c0000ff00"..skillLevel.."/"..maxSkillLevel)
			end
		else
			Glance.Functions.resetButton(Glance.Buttons.Professions,Glance.Buttons.Rep,"LEFT","RIGHT",Glance.Variables.spacer,"Professions")
		end
		if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateProfessions()") end
	else Glance.Functions.resetButton(Glance.Buttons.Professions,Glance.Buttons.Rep,"LEFT","RIGHT",0,"") end
end

---------------------------
-- lag update
---------------------------
function Glance.Functions.updateLag()
	if Glance_Options.showLag then
		local bandwidthIn, bandwidthOut, latencyHome, latencyWorld = GetNetStats()
		Glance.Functions.resetButton(Glance.Buttons.Lag,Glance.Buttons.Professions,"LEFT","RIGHT",Glance.Variables.spacer,"|rLag: "..Glance.Functions.formatLag(latencyHome))
		--if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateLag()") end
	else Glance.Functions.resetButton(Glance.Buttons.Lag,Glance.Buttons.Professions,"LEFT","RIGHT",0,"") end
end

---------------------------
-- fps update
---------------------------
function Glance.Functions.updateFPS()
	if Glance_Options.showFPS then
		Glance.Functions.stats(Glance.Variables.fps,GetFramerate())
		Glance.Functions.resetButton(Glance.Buttons.FPS,Glance.Buttons.Lag,"LEFT","RIGHT",Glance.Variables.spacer,"|rFPS: "..Glance.Functions.formatFPS(GetFramerate()))
		--if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateFPS()") end
	else Glance.Functions.resetButton(Glance.Buttons.FPS,Glance.Buttons.Lag,"LEFT","RIGHT",0,"") end
end

---------------------------
-- mem update
---------------------------
function Glance.Functions.updateMem()
	if Glance_Options.showMem then
		Glance.Functions.resetButton(Glance.Buttons.Mem,Glance.Buttons.FPS,"LEFT","RIGHT",Glance.Variables.spacer,"|rMem: |cff00ff00"..Glance.Functions.formatMem())
		--if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateMem()") end
	else Glance.Functions.resetButton(Glance.Buttons.Mem,Glance.Buttons.FPS,"LEFT","RIGHT",0,"") end
end

---------------------------
-- mount update
---------------------------
function Glance.Functions.updateMounts()
	if Glance_Options.showMounts then
		Glance.Functions.resetButton(Glance.Buttons.Mounts,Glance.Buttons.Mem,"LEFT","RIGHT",Glance.Variables.spacer,"Mounts: |cff00ff00"..GetNumCompanions("MOUNT"))
		if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateMounts()") end
	else Glance.Functions.resetButton(Glance.Buttons.Mounts,Glance.Buttons.Mem,"LEFT","RIGHT",0,"") end
end

---------------------------
-- pet update
---------------------------
function Glance.Functions.updatePets()
	if Glance_Options.showPets then
		Glance.Functions.resetButton(Glance.Buttons.Pets,Glance.Buttons.Mounts,"LEFT","RIGHT",Glance.Variables.spacer,"Pets: |cff00ff00"..GetNumCompanions("CRITTER"))
		if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updatePets()") end
	else Glance.Functions.resetButton(Glance.Buttons.Pets,Glance.Buttons.Mounts,"LEFT","RIGHT",0,"") end
end


---------------------------
-- wintergrasp update
---------------------------
function Glance.Functions.updateWG()
	if Glance_Options.showWG then
		if WorldMapFrame:IsVisible() == nil then
			local pvpID, localizedName, isActive, canQueue, sec, canEnter = GetWorldPVPAreaInfo(1)
			local control = "|r"
			local area = GetCurrentMapAreaID()
			SetMapByID(485) --708 for tol barad - 485 for wg
			for i = 1, GetNumMapLandmarks() do
				local index = select(3, GetMapLandmarkInfo(i))
				if index == 46 then
					control = "|cFF69CCF0"
				elseif index == 48 then
					control = "|cFFC41F3B"
				end
			end
			if not isActive then
				if sec < 60 and sec > 0 then -- 1 minute warning (seconds)
					Glance.Buttons.WG:SetFormattedText("%s Wintergrasp: |cffff0000%d|rs", control, (sec or 0))
				elseif sec <= 300 then -- 5 minute warning (minutes)
					Glance.Buttons.WG:SetFormattedText("%s Wintergrasp: |cffff0000%d|rm", control, (math.floor(sec/60) or 0))
				elseif sec > 300 and sec <= 3600 then -- show minutes
					Glance.Buttons.WG:SetFormattedText("%s Wintergrasp: |cff00ff00%d|rm", control, (math.floor(sec/60) or 0))
				elseif sec > 3600 then -- show hours
					local hour, min
					hour = (math.floor(sec/3600) or 0)
					min	= (math.floor((sec-(hour*3600))/60) or 0)
					Glance.Buttons.WG:SetFormattedText("%s Wintergrasp: |cff00ff00%d|rh |cff00ff00%d|rm", control, hour, min)
				end
			else -- in session
				Glance.Buttons.WG:SetFormattedText("Wintergrasp: |cffff00000|rm")
			end
			--SetMapToCurrentZone()
			SetMapByID(area)
			Glance.Buttons.WG:SetWidth(Glance.Buttons.WG:GetTextWidth())
			Glance.Buttons.WG:SetPoint("LEFT", Glance.Buttons.Pets, "RIGHT", Glance.Variables.spacer, 0)
			--if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateWG()") end
		end
	else Glance.Functions.resetButton(Glance.Buttons.WG,Glance.Buttons.Pets,"LEFT","RIGHT",0,"") end
end

---------------------------
-- tol barad update
---------------------------
function Glance.Functions.updateTB()
	if Glance_Options.showTB then
		if WorldMapFrame:IsVisible() == nil then
			local pvpID, localizedName, isActive, canQueue, sec, canEnter = GetWorldPVPAreaInfo(2)
			local control = "|r"
			local area = GetCurrentMapAreaID()
			SetMapByID(708) --708 for tol barad - 485 for wg
			for i = 1, GetNumMapLandmarks() do
				local index = select(3, GetMapLandmarkInfo(i))
				if index == 46 then
					control = "|cFF69CCF0"
				elseif index == 48 then
					control = "|cFFC41F3B"
				end
			end
			if not isActive then
				if sec < 60 and sec > 0 then -- 1 minute warning (seconds)
					Glance.Buttons.TB:SetFormattedText("%s Tol Barad: |cffff0000%d|rs", control, (sec or 0))
				elseif sec <= 300 then -- 5 minute warning (minutes)
					Glance.Buttons.TB:SetFormattedText("%s Tol Barad: |cffff0000%d|rm", control, (math.floor(sec/60) or 0))
				elseif sec > 300 and sec <= 3600 then -- show minutes
					Glance.Buttons.TB:SetFormattedText("%s Tol Barad: |cff00ff00%d|rm", control, (math.floor(sec/60) or 0))
				elseif sec > 3600 then -- show hours
					local hour, min
					hour = (math.floor(sec/3600) or 0)
					min	= (math.floor((sec-(hour*3600))/60) or 0)
					Glance.Buttons.TB:SetFormattedText("%s Tol Barad: |cff00ff00%d|rh |cff00ff00%d|rm", control, hour, min)
				end
			else -- in session
				Glance.Buttons.TB:SetFormattedText("Tol Barad: |cffff00000|rm")
			end
			--SetMapToCurrentZone()
			SetMapByID(area)
			Glance.Buttons.TB:SetWidth(Glance.Buttons.TB:GetTextWidth())
			Glance.Buttons.TB:SetPoint("LEFT", Glance.Buttons.WG, "RIGHT", Glance.Variables.spacer, 0)
			--if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateTB()") end
		end
	else Glance.Functions.resetButton(Glance.Buttons.TB,Glance.Buttons.WG,"LEFT","RIGHT",0,"") end
end

---------------------------
-- location update
---------------------------
function Glance.Functions.updateLocation()
	if Glance_Options.showLocation then
		if WorldMapFrame:IsVisible() == nil then
			local unitx, unity = GetPlayerMapPosition("player")
			local name, subName
			if IsInInstance() then
				name, subName = select(1, GetInstanceInfo()), select(4, GetInstanceInfo())
			else
				name, subName = GetZoneText(), GetSubZoneText()
			end
			Glance.Buttons.Location:SetFormattedText("|cff6fb8f0%s - |cff6ff0ee%s (%d, %d)", name, subName, (unitx * 100), (unity * 100))
			Glance.Buttons.Location:SetWidth(Glance.Buttons.Location:GetTextWidth())
			Glance.Buttons.Location:SetPoint("RIGHT", Glance.Buttons.Time, "LEFT", -Glance.Variables.spacer, 0)
			--if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateLocation()") end
		end
	else Glance.Functions.resetButton(Glance.Buttons.Location,Glance.Buttons.Time,"RIGHT","LEFT",0,"") end
end

---------------------------
-- clock update
---------------------------
function Glance.Functions.updateClock()
	if Glance_Options.showClock then
		local hour, min = GetGameTime()
		local lhour = tonumber(date("%H"))
		if Glance_Options.serverTime then
			Glance.Buttons.Time:SetFormattedText("|r%s:%s %s server", Glance.Functions.GetHour(hour), Glance.Functions.GetMin(min), Glance.Functions.GetDST(hour))
		else
			Glance.Buttons.Time:SetFormattedText("|r%s:%s %s local", Glance.Functions.GetHour(lhour), Glance.Functions.GetMin(min), Glance.Functions.GetDST(lhour))
		end
		Glance.Buttons.Time:SetWidth(Glance.Buttons.Time:GetTextWidth())
		Glance.Buttons.Time:SetPoint("RIGHT", Glance.Frames.mainFrame, "RIGHT", -Glance.Variables.spacer, 0)
		--if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFF69CCF0UDT: Glance.Functions.updateClock()") end
	else Glance.Functions.resetButton(Glance.Buttons.Time,Glance.Frames.mainFrame,"RIGHT","RIGHT",0,"") end
end


